//+------------------------------------------------------------------+
//|                                                  MTF_MAcross.mq4 |
//|                           Copyright source code 2006, Keris2112 |
//|                                      based on bigbear3391's idea |
//|                                       programmed by samkoke      |
//+------------------------------------------------------------------+
#property copyright "Copyright source code 2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 3
#property indicator_color1 RoyalBlue
#property indicator_color2 Red
#property indicator_color3 Yellow



//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=0;
extern int MAfastPeriod=8;
extern int MAslowPeriod=14;


double UpBuffer1[];
double DnBuffer1[];
double FtBuffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicator line
  SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
  
   
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexBuffer(2,FtBuffer1);

 
  
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   IndicatorShortName("Samkoke_MA2");  
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF MA Cross                                                     |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i, trend, shift,limit,y=0,counted_bars=IndicatorCounted();
   double ExtMapBuffer1, ExtMapBuffer2;
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
    UpBuffer1[i]=0;
    DnBuffer1[i]=0;
    FtBuffer1[i]=0;
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
     
   ExtMapBuffer1=iMA(NULL,TimeFrame,MAfastPeriod,0,MODE_LWMA,PRICE_CLOSE,y);
   ExtMapBuffer2=iMA(NULL,TimeFrame,MAslowPeriod,0,MODE_EMA,PRICE_OPEN,y);
  
     if (ExtMapBuffer1>ExtMapBuffer2)  UpBuffer1[i]=1;
	  if (ExtMapBuffer1<ExtMapBuffer2)  DnBuffer1[i]=1;
	  if (UpBuffer1[i]==0&&DnBuffer1[i]==0)   FtBuffer1[i]=1;
	     
   }  
     
//
    
   return(0);
  }
//+------------------------------------------------------------------+